// Generated by CoffeeScript 1.8.0
(function() {
  "use strict";
  var LITERALS, TYPES, Tools, Types, breakIfEqual, createForce, instanceOf, testValues, typeOf, _,
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  instanceOf = function(type, value) {
    return value instanceof type;
  };

  typeOf = function(value, type) {
    if (type == null) {
      type = 'object';
    }
    return typeof value === type;
  };

  LITERALS = {
    'Boolean': false,
    'String': '',
    'Object': {},
    'Array': [],
    'Function': function() {},
    'Number': (function() {
      var number;
      number = new Number;
      number["void"] = true;
      return number;
    })()
  };

  TYPES = {
    'Undefined': function(value) {
      return value === void 0;
    },
    'Null': function(value) {
      return value === null;
    },
    'Function': function(value) {
      return typeOf(value, 'function');
    },
    'Boolean': function(value) {
      return typeOf(value, 'boolean');
    },
    'String': function(value) {
      return typeOf(value, 'string');
    },
    'Array': function(value) {
      return typeOf(value) && instanceOf(Array, value);
    },
    'RegExp': function(value) {
      return typeOf(value) && instanceOf(RegExp, value);
    },
    'Date': function(value) {
      return typeOf(value) && instanceOf(Date, value);
    },
    'Number': function(value) {
      return typeOf(value, 'number') && (value === value) || (typeOf(value) && instanceOf(Number, value));
    },
    'Object': function(value) {
      return typeOf(value) && (value !== null) && !instanceOf(Boolean, value) && !instanceOf(Number, value) && !instanceOf(Array, value) && !instanceOf(RegExp, value) && !instanceOf(Date, value);
    },
    'NaN': function(value) {
      return typeOf(value, 'number') && (value !== value);
    },
    'Defined': function(value) {
      return value !== void 0;
    }
  };

  TYPES.StringOrNumber = function(value) {
    return TYPES.String(value) || TYPES.Number(value);
  };

  Types = _ = {
    parseIntBase: 10
  };

  createForce = function(type) {
    var convertType;
    convertType = function(value) {
      switch (type) {
        case 'Number':
          if ((_.isNumber(value = parseInt(value, _.parseIntBase))) && !value["void"]) {
            return value;
          }
          break;
        case 'String':
          if (_.isStringOrNumber(value)) {
            return value + '';
          }
          break;
        default:
          if (Types['is' + type](value)) {
            return value;
          }
      }
    };
    return function(value, replacement) {
      if ((value != null) && void 0 !== (value = convertType(value))) {
        return value;
      }
      if ((replacement != null) && void 0 !== (replacement = convertType(replacement))) {
        return replacement;
      }
      return LITERALS[type];
    };
  };

  testValues = function(predicate, breakState, values) {
    var value, _i, _len;
    if (values == null) {
      values = [];
    }
    if (values.length < 1) {
      return predicate === TYPES.Undefined;
    }
    for (_i = 0, _len = values.length; _i < _len; _i++) {
      value = values[_i];
      if (predicate(value) === breakState) {
        return breakState;
      }
    }
    return !breakState;
  };

  breakIfEqual = true;

  (function() {
    var name, predicate, _results;
    _results = [];
    for (name in TYPES) {
      predicate = TYPES[name];
      _results.push((function(name, predicate) {
        Types['is' + name] = predicate;
        Types['not' + name] = function(value) {
          return !predicate(value);
        };
        Types['has' + name] = function() {
          return testValues(predicate, breakIfEqual, arguments);
        };
        Types['all' + name] = function() {
          return testValues(predicate, !breakIfEqual, arguments);
        };
        if (name in LITERALS) {
          return Types['force' + name] = createForce(name);
        }
      })(name, predicate));
    }
    return _results;
  })();

  Types.intoArray = function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    if (args.length < 2) {
      if (_.isString(args[0])) {
        args = args.join('').replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' ').split(' ');
      } else if (_.isArray(args[0])) {
        args = args[0];
      }
    }
    return args;
  };

  Types["typeof"] = function(value) {
    var name, predicate;
    for (name in TYPES) {
      predicate = TYPES[name];
      if (predicate(value) === true) {
        return name.toLowerCase();
      }
    }
  };

  Tools = (function(_super) {
    var eachArray, eachObject, extend;

    __extends(Tools, _super);

    function Tools() {
      return Tools.__super__.constructor.apply(this, arguments);
    }

    Tools.Types = _;

    eachArray = function(array, callback, find) {
      var index, length, result;
      index = -1;
      length = array.length;
      if (find) {
        while (++index < length) {
          result = callback(array[index], index);
          if (result === find) {
            return true;
          }
        }
      } else {
        while (++index < length) {
          callback(array[index], index);
        }
      }
      return false;
    };

    eachObject = function(object, callback, find) {
      var key, result, value;
      if (find) {
        for (key in object) {
          value = object[key];
          result = callback(value, key);
          if (result === find) {
            return true;
          }
        }
      } else {
        for (key in object) {
          value = object[key];
          callback(value, key);
        }
      }
      return false;
    };

    Tools.each = function(object, callback, find) {
      if (_.isArray(object)) {
        return eachArray(object, callback, find);
      }
      return eachObject(object, callback, find);
    };

    extend = function(target, source, append) {
      var key, value;
      if (target == null) {
        target = {};
      }
      for (key in source) {
        value = source[key];
        if (_.isObject(value)) {
          extend(target[key], value, append);
        } else {

        }
        if (!(append && target.hasOwnProperty(key))) {
          target[key] = value;
        }
      }
      return target;
    };

    Tools.extend = function(target, source) {
      return extend(_.forceObject(target), _.forceObject(source));
    };

    Tools.append = function(target, source) {
      return extend(_.forceObject(target), _.forceObject(source), true);
    };

    Tools.insertSort = function() {
      var array, current, index, length, prev, _i;
      array = _.intoArray.apply(this, arguments);
      if (array.length > 1) {
        length = array.length - 1;
        for (index = _i = 1; 1 <= length ? _i <= length : _i >= length; index = 1 <= length ? ++_i : --_i) {
          current = array[index];
          prev = index - 1;
          while ((prev >= 0) && (array[prev] > current)) {
            array[prev + 1] = array[prev];
            --prev;
          }
          array[+prev + 1] = current;
        }
      }
      return array;
    };

    return Tools;

  })(_);

  module.exports= Tools;

}).call(this);
